interface MirrorData {
    $type: 'array' | 'object';
    $mirror: Mirror;
    $maxItems?: number;
}
interface MirrorAction {
    $from: string;
    $action?: 'cat' | 'copy' | 'merge';
    $data?: string | MirrorData;
}
declare type Constant = string | number | boolean | object | any[];
interface ParentPath {
    from: string[];
    to: string[];
}
export interface Mirror {
    [key: string]: string | Constant | MirrorAction;
}
declare enum CodeType {
    line = 0,
    raw = 1
}
declare type Buffer = Array<{
    type: CodeType;
    code: string;
}>;
export default class CodeBuffer {
    buffer: Buffer;
    root: string;
    trackerIndex: number;
    constructor(options?: {
        root?: string;
    });
    transformGetter(path: string[], variable: string): string;
    transfromSetter(to: string[], setter: string, content: string): string;
    getParams(parentPath?: ParentPath): {
        getter: string;
        setter: string;
    };
    fromPath(from: string[], to: string[], parentPath?: ParentPath): void;
    fromConstant(constant: any, to: string[], parentPath?: ParentPath): void;
    addCat(from: string, to: string[], data: any, parentPath?: ParentPath): void;
    addCopy(from: string, to: string[], data: MirrorData, parentPath?: ParentPath): void;
    walk(mirror: Mirror, parentPath?: ParentPath): void;
    toString(): string;
}
export {};
