"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const CodeBuffer_1 = __importDefault(require("./CodeBuffer"));
function compile(options) {
    let json;
    const { source, rootVar } = options;
    try {
        json = JSON.parse(source);
    }
    catch (e) {
        console.error(`json parse error: ` + e.message);
        return {
            code: '',
            errors: [{
                    code: 1,
                    message: 'json parse error: ' + e.message
                }]
        };
    }
    const buffer = new CodeBuffer_1.default({
        root: rootVar
    });
    if ('$title' in json) {
        delete json.$title;
    }
    buffer.walk(json);
    const code = buffer.toString();
    return {
        code,
        errors: []
    };
}
exports.default = compile;
//# sourceMappingURL=compiler.js.map